# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import pulumi
import pulumi.runtime
from .. import utilities, tables

class Monitor(pulumi.CustomResource):
    defaults_from: pulumi.Output[str]
    destination: pulumi.Output[str]
    """
    Specify an alias address for monitoring
    """
    interval: pulumi.Output[int]
    """
    Check interval in seconds
    """
    ip_dscp: pulumi.Output[int]
    manual_resume: pulumi.Output[str]
    name: pulumi.Output[str]
    """
    Name of the monitor
    """
    parent: pulumi.Output[str]
    """
    Existing LTM monitor to inherit from
    """
    receive: pulumi.Output[str]
    """
    Expected response string
    """
    receive_disable: pulumi.Output[str]
    reverse: pulumi.Output[str]
    send: pulumi.Output[str]
    """
    Request string to send
    """
    time_until_up: pulumi.Output[int]
    timeout: pulumi.Output[int]
    """
    Timeout in seconds
    """
    transparent: pulumi.Output[str]
    def __init__(__self__, __name__, __opts__=None, defaults_from=None, destination=None, interval=None, ip_dscp=None, manual_resume=None, name=None, parent=None, receive=None, receive_disable=None, reverse=None, send=None, time_until_up=None, timeout=None, transparent=None):
        """
        `bigip_ltm_monitor` Configures a custom monitor for use by health checks.
        
        For resources should be named with their "full path". The full path is the combination of the partition + name of the resource. For example /Common/my-pool.
        
        :param str __name__: The name of the resource.
        :param pulumi.ResourceOptions __opts__: Options for the resource.
        :param pulumi.Input[str] defaults_from
        :param pulumi.Input[str] destination: Specify an alias address for monitoring
        :param pulumi.Input[int] interval: Check interval in seconds
        :param pulumi.Input[int] ip_dscp
        :param pulumi.Input[str] manual_resume
        :param pulumi.Input[str] name: Name of the monitor
        :param pulumi.Input[str] parent: Existing LTM monitor to inherit from
        :param pulumi.Input[str] receive: Expected response string
        :param pulumi.Input[str] receive_disable
        :param pulumi.Input[str] reverse
        :param pulumi.Input[str] send: Request string to send
        :param pulumi.Input[int] time_until_up
        :param pulumi.Input[int] timeout: Timeout in seconds
        :param pulumi.Input[str] transparent
        """
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['defaults_from'] = defaults_from

        __props__['destination'] = destination

        __props__['interval'] = interval

        __props__['ip_dscp'] = ip_dscp

        __props__['manual_resume'] = manual_resume

        if not name:
            raise TypeError('Missing required property name')
        __props__['name'] = name

        if not parent:
            raise TypeError('Missing required property parent')
        __props__['parent'] = parent

        __props__['receive'] = receive

        __props__['receive_disable'] = receive_disable

        __props__['reverse'] = reverse

        __props__['send'] = send

        __props__['time_until_up'] = time_until_up

        __props__['timeout'] = timeout

        __props__['transparent'] = transparent

        super(Monitor, __self__).__init__(
            'f5bigip:ltm/monitor:Monitor',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

