# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import pulumi
import pulumi.runtime
from .. import utilities, tables

class SelfIp(pulumi.CustomResource):
    ip: pulumi.Output[str]
    """
    The Self IP's address and netmask.
    """
    name: pulumi.Output[str]
    """
    Name of the selfip
    """
    traffic_group: pulumi.Output[str]
    """
    Specifies the traffic group, defaults to `traffic-group-local-only` if not specified.
    """
    vlan: pulumi.Output[str]
    """
    Specifies the VLAN for which you are setting a self IP address. This setting must be provided when a self IP is created.
    """
    def __init__(__self__, __name__, __opts__=None, ip=None, name=None, traffic_group=None, vlan=None):
        """
        `bigip_net_selfip` Manages a selfip configuration
        
        Resource should be named with their "full path". The full path is the combination of the partition + name of the resource, for example /Common/my-selfip.
        
        :param str __name__: The name of the resource.
        :param pulumi.ResourceOptions __opts__: Options for the resource.
        :param pulumi.Input[str] ip: The Self IP's address and netmask.
        :param pulumi.Input[str] name: Name of the selfip
        :param pulumi.Input[str] traffic_group: Specifies the traffic group, defaults to `traffic-group-local-only` if not specified.
        :param pulumi.Input[str] vlan: Specifies the VLAN for which you are setting a self IP address. This setting must be provided when a self IP is created.
        """
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not ip:
            raise TypeError('Missing required property ip')
        __props__['ip'] = ip

        if not name:
            raise TypeError('Missing required property name')
        __props__['name'] = name

        __props__['traffic_group'] = traffic_group

        if not vlan:
            raise TypeError('Missing required property vlan')
        __props__['vlan'] = vlan

        super(SelfIp, __self__).__init__(
            'f5bigip:net/selfIp:SelfIp',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

